/*****************************************************************************

		Copyright (c) My Company

 Project:  MYPROJ
 FileName: DIRLIST.PRO
 Purpose: No description
 Written by: Visual Prolog
 Comments:
******************************************************************************/

include "myproj.inc"
include "myproj.con"
include "hlptopic.con"
include "iodecl.con" 

%BEGIN_WIN Directory

/******************************************************
	Return subdirectories and files in a DIR
******************************************************/
   domains
     stamp=s(integer Hour,integer Min,integer Sec,integer Year,
	     integer Month,integer Day,long Size);
          dir
   predicates
      nondeterm get_files(string Path,string FileName,stamp)
   clauses
      get_files (PATH, SUBDIR, dir):-
         concat(PATH,"*.*",PP), 
         dirfiles(PP,fa_subdir,SUBDIR,_,_,_,_,_,_,_,_),
         SUBDIR ><  ".".
      get_files(PATH,FName,s(Hour,Min,Sec,Year,Month,Day,Size)):-
         concat(PATH,"*.*",PP),
         dirfiles(PP,fa_normal,FName,_,Hour,Min,Sec,Year,Month,Day,Size).
/******************************************************
	Fill a listbox with the files in a subdir
******************************************************/

predicates
      fill_lbox(window,string Path)
      fill_lbox(window,string FileName,stamp)
   clauses
      fill_lbox(Win,Path):-
         lbox_Clear(Win),
         get_files(Path,FName,STAMP),
         fill_lbox(Win,FName,STAMP),
         fail.
      fill_lbox(_Win,_Path).
      fill_lbox(Win,SubDir,dir):-
         format(Str,"%\t%",SubDir,"<dir>"),
         lbox_Add(Win, -1, Str). 
      fill_lbox(Win,FName,s(Hour,Min,Sec,Year,Month,Day,Size)):-
         format(Str,"%\t%8\t%2:%2:%2\t%4/%2/%2", 
              FName,Size,Hour,Min,Sec,Year,Month,Day),
         lbox_Add(Win,-1,Str).

predicates
      get_path(string Item,string Path,string Rest) 
 clauses
      get_path(Item,Path,Rest):-
         searchchar(Item, '\t',Pos),
         Len=Pos-1,
         frontstr(Len,Item,Path,Rest).


%BEGIN_WIN Directory
/**************************************************************************
        Creation and event handling for window: Directory
**************************************************************************/

constants
%BEGIN Directory, CreateParms, 14:36:08-18.1.2007, Code automatically updated!
  win_directory_WinType = w_TopLevel
  win_directory_Flags = [wsf_SizeBorder,wsf_TitleBar,wsf_Maximize,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren,wsf_Maximized]
  win_directory_RCT = rct(100,80,440,240)
  win_directory_Menu = no_menu
  win_directory_Title = "Directory"
  win_directory_Help = idh_contents
%END Directory, CreateParms

predicates

  win_directory_eh : EHANDLER

clauses

  win_directory_Create(_Parent):-
	win_Create(win_directory_WinType,win_directory_RCT,win_directory_Title,
		   win_directory_Menu,_Parent,win_directory_Flags,win_directory_eh,0).

%BEGIN Directory, e_Create
  win_directory_eh(_Win,e_Create(_),0):-!,
%BEGIN Directory, InitControls, 14:36:08-18.1.2007, Code automatically updated!
	win_CreateControl(wc_LBox,rct(0,3,336,157),"",_Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_NoBorder,wsf_UseTabStops,wsf_MultiSelect],idc_listbox),
%END Directory, InitControls
%BEGIN Directory, ToolbarCreate, 14:36:08-18.1.2007, Code automatically updated!
%END Directory, ToolbarCreate
   LBWIN=win_GetCtlHandle(_Win,idc_listbox),
   lbox_SetTabStops(LBWIN,[0,75,125,175,225]), 
   Font=font_Create(ff_Fixed,[],10),
   win_SetFont(LBWIN,Font),
   win_SetText(_Win,"C:\\"), 
   fill_lbox(LBWIN,"C:\\"),
   !.
%END Directory, e_Create
%MARK Directory, new events

%BEGIN Directory, e_Size
  win_directory_eh(_Win,e_Size(_Width,_Height),0):-!,
      LBWin=win_GetCtlHandle(_Win,idc_listbox), 
      win_Move(LBWin,rct(0,0,_Width,_Height)),
ifdef use_tbar
	toolbar_Resize(_Win),
enddef
	!.
%END Directory, e_Size

%BEGIN Directory, e_Menu, Parent window 
  win_directory_eh(Win,e_Menu(ID,CAS),0):-!,
	PARENT = win_GetParent(Win),
	win_SendEvent(PARENT,e_Menu(ID,CAS)),
	!.
%END Directory, e_Menu, Parent window

%END_WIN Directory

